synapse-dev mailing list archives

Site index · List index
Message view « Date » · « Thread »
Top « Date » · « Thread »
From "Ruwan Linton (JIRA)" <j...@apache.org>
Subject [jira] Commented: (SYNAPSE-396) Consider reducing requisite dependencies of Synapse Core
Date Sat, 12 Jul 2008 13:51:32 GMT

    [ https://issues.apache.org/jira/browse/SYNAPSE-396?page=com.atlassian.jira.plugin.system.issuetabpanels:comment-tabpanel&focusedCommentId=12613086#action_12613086
] 

Ruwan Linton commented on SYNAPSE-396:
--------------------------------------

Oleg,

First of all very interesting idea, and this can be partially fixed using OSGi's optional
resolutions of dependencies. If I further explain this, you can specify the import dependency
resolution as optional in the META-INF of the OSGi bundle, in which case these dependencies
will be resolved on demand. So if your execution cycle is not gonna touch the utility classes
that uses spring, then you do not need to have the Spring bundle on the OSGi environment.
So in that sense you do not require all these deps when running on an OSGi environment (this
solution is only valid when you are on an OSGi environment and that is why I specified this
as a partial solution)

BTW: have you noticed that synapse jar files are already OSGi bundles, but for the moment
resolution is *not* optional and this is a trivial fix.

Regarding the transports dependency on the synapse-core, I also think that we should not depend
on the transports and if there is any dependency, we should be able to decouple those. At
the same time in order to address the issue of "Do we require all transports?" I think we
need to break the transports jar into set of transport jars (for example nhttp-transport,
jms-transport etc...) and even on the synapse distribution we may exclude some of the transports
for example like FIX, which has considerable other transitive dependencies associated with
it. 

> Consider reducing requisite dependencies of Synapse Core
> --------------------------------------------------------
>
>                 Key: SYNAPSE-396
>                 URL: https://issues.apache.org/jira/browse/SYNAPSE-396
>             Project: Synapse
>          Issue Type: Wish
>          Components: Core
>    Affects Versions: 1.3
>            Reporter: Oleg Kalnichevski
>
> Folks
> I understand that the greatest majority of Synapse users use it as a standalone application
and are unlikely  to care much about external dependencies of individual modules. However,
as the Synapse user base grows it will become more diverse as well. There will be users who
may want to (or have to) use parts of Synapse embedded into a larger runtime either as OSGi
bundles, GBeans or a set of plain old jars. They are also likely to concerned about total
number of external dependencies in order to minimize possibility of versioning conflicts.

> The present situation with external dependencies can only be described as depressing.
Synapse Core is currently dependent either directly or transitively on several dozens of libraries,
which makes it very difficult to embed. 
> More details to follow

-- 
This message is automatically generated by JIRA.
-
You can reply to this email to add a comment to the issue online.


---------------------------------------------------------------------
To unsubscribe, e-mail: dev-unsubscribe@synapse.apache.org
For additional commands, e-mail: dev-help@synapse.apache.org


Mime
View raw message